############################################################
# wxPyCalc-refactored.py
#
# Created 10/19/2008 by Mike Driscoll
#
# Description: A basic calculator
############################################################

import wx

class MainPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent=parent, id=wx.ID_ANY)
        self.parent = parent
        self.formula = []
        self.currentVal = "0"
        self.previousVal = "0"
        self.operator = None
        self.operatorFlag = False
        self.createAndlayoutWidgets()
        
    def createAndlayoutWidgets(self):
        mainSizer = wx.BoxSizer(wx.VERTICAL)
        masterBtnSizer = wx.BoxSizer(wx.HORIZONTAL)
        vBtnSizer = wx.BoxSizer(wx.VERTICAL)
        numSizer  = wx.GridBagSizer(hgap=5, vgap=5)
        
        self.displayTxt = wx.TextCtrl(self, wx.ID_ANY, "0", 
                                      size=(155,-1),
                                      style=wx.TE_RIGHT|wx.TE_READONLY)
                                          
        # number buttons
        size=(45, 45)
        zeroBtn = wx.Button(self, wx.ID_ANY, "0", size=size)
        oneBtn = wx.Button(self, wx.ID_ANY, "1", size=size)
        twoBtn = wx.Button(self, wx.ID_ANY, "2", size=size)
        threeBtn = wx.Button(self, wx.ID_ANY, "3", size=size)
        fourBtn = wx.Button(self, wx.ID_ANY, "4", size=size)
        fiveBtn = wx.Button(self, wx.ID_ANY, "5", size=size)
        sixBtn = wx.Button(self, wx.ID_ANY, "6", size=size)
        sevenBtn = wx.Button(self, wx.ID_ANY, "7", size=size)
        eightBtn = wx.Button(self, wx.ID_ANY, "8", size=size)
        nineBtn = wx.Button(self, wx.ID_ANY, "9", size=size)
        
        numBtnLst = [zeroBtn, oneBtn, twoBtn, threeBtn, fourBtn, fiveBtn,
                     sixBtn, sevenBtn, eightBtn, nineBtn]
        for button in numBtnLst:
            button.Bind(wx.EVT_BUTTON, self.onButton)
        
        # operator buttons
        divBtn = wx.Button(self, wx.ID_ANY, "/", size=size)
        multiBtn = wx.Button(self, wx.ID_ANY, "*", size=size)
        subBtn = wx.Button(self, wx.ID_ANY, "-", size=size)
        addBtn = wx.Button(self, wx.ID_ANY, "+", size=(45,100))
        equalsBtn = wx.Button(self, wx.ID_ANY, "Enter", size=(45,100))
        equalsBtn.Bind(wx.EVT_BUTTON, self.onCalculate)
        
        opBtnLst = [divBtn, multiBtn, subBtn, addBtn]
        for button in opBtnLst:
            button.Bind(wx.EVT_BUTTON, self.onOperation)
        
        numSizer.Add(divBtn, pos=(0,0), flag=wx.CENTER)
        numSizer.Add(multiBtn, pos=(0,1), flag=wx.CENTER)
        numSizer.Add(subBtn, pos=(0,2), flag=wx.CENTER)
        numSizer.Add(sevenBtn, pos=(1,0), flag=wx.CENTER)
        numSizer.Add(eightBtn, pos=(1,1), flag=wx.CENTER)
        numSizer.Add(nineBtn, pos=(1,2), flag=wx.CENTER)
        numSizer.Add(fourBtn, pos=(2,0), flag=wx.CENTER)
        numSizer.Add(fiveBtn, pos=(2,1), flag=wx.CENTER)
        numSizer.Add(sixBtn, pos=(2,2), flag=wx.CENTER)
        numSizer.Add(oneBtn, pos=(3,0), flag=wx.CENTER)
        numSizer.Add(twoBtn, pos=(3,1), flag=wx.CENTER)
        numSizer.Add(threeBtn, pos=(3,2), flag=wx.CENTER)
        numSizer.Add(zeroBtn, pos=(4,1), flag=wx.CENTER)
        
        vBtnSizer.Add(addBtn, 0)
        vBtnSizer.Add(equalsBtn, 0)
        
        masterBtnSizer.Add(numSizer, 0, wx.ALL, 5)
        masterBtnSizer.Add(vBtnSizer, 0, wx.ALL, 5)
        mainSizer.Add(self.displayTxt, 0, wx.ALL, 5)
        mainSizer.Add(masterBtnSizer)
        self.SetSizer(mainSizer)
        mainSizer.Fit(self.parent)
        
    def onOperation(self, event):
        """
        Add an operator to the equation
        """
        print "onOperation handler fired"

    def onButton(self, event):
        """
        Keeps the display up to date
        """
        # Get the button object
        buttonObj = event.GetEventObject()
        # Get the label of the button object
        buttonLbl = buttonObj.GetLabel()
        
    def onCalculate(self):
        """
        Calculate the total
        """
        print 'in onCalculate'

class PyCalcFrame(wx.Frame):
    def __init__(self):
        wx.Frame.__init__(self, parent=None, id=wx.ID_ANY, 
                          title="Calculator")
        panel = MainPanel(self)
                        
class PyCalc(wx.App):
    def __init__(self, redirect=False, filename=None):
        wx.App.__init__(self, redirect, filename)
        
    def OnInit(self):
        # create frame here
        frame = PyCalcFrame()
        frame.Show()
        return True
    
def main():
    app = PyCalc()
    app.MainLoop()
    
if __name__ == "__main__":
    main()
